## notcurses 2.3.13+dfsg.1

=== CMakeLists.txt ===
# 3.14.0 introduced NAME_WLE
cmake_minimum_required(VERSION 3.14.0)
project(notcurses VERSION 2.3.13
  DESCRIPTION "Blingful UI for modern terminal emulators"
  HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
  LANGUAGES C CXX)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

include(CTest)
include(GNUInstallDirs)
include(CMakeDependentOption)
include(FeatureSummary)

###################### USER-SELECTABLE OPTIONS ###########################
# BUILD_TESTING is defined by CTest
option(DFSG_BUILD "DFSG build (no non-free media/code)" OFF)
option(USE_COVERAGE "Assess code coverage with llvm-cov/lcov" OFF)
cmake_dependent_option(
  USE_DOCTEST "Build notcurses-tester with doctest" ON
  "${BUILD_TESTING}" OFF
)
option(USE_DOXYGEN "Build HTML cross reference with doxygen" OFF)
option(USE_PANDOC "Build man pages and HTML reference with pandoc" ON)
option(USE_POC "Build small, uninstalled proof-of-concept binaries" ON)
option(USE_QRCODEGEN "Enable libqrcodegen QR code support" OFF)
option(USE_READLINE "Enable libreadline line-editing support" ON)
option(USE_STATIC "Build static libraries (in addition to shared)" ON)
set(USE_MULTIMEDIA "ffmpeg" CACHE STRING "Multimedia engine, one of 'ffmpeg', 'oiio', or 'none'")
set_property(CACHE USE_MULTIMEDIA PROPERTY STRINGS ffmpeg oiio none)
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE
    STRING "Choose the build mode." FORCE)
endif()
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release MinSizeRel RelWithDebInfo Coverage)
############## END (additional) USER-SELECTABLE OPTIONS ##################
set(USE_FFMPEG OFF)
set(USE_OIIO OFF)
if(${USE_MULTIMEDIA} STREQUAL "ffmpeg")
  set(USE_FFMPEG ON)
elseif(${USE_MULTIMEDIA} STREQUAL "oiio")
  set(USE_OIIO ON)
elseif(NOT ${USE_MULTIMEDIA} STREQUAL "none")
  message(FATAL_ERROR "USE_MULTIMEDIA must be one of 'oiio', 'ffmpeg', 'none' (was '${USE_MULTIMEDIA}')")
endif()

string(APPEND CMAKE_C_FLAGS_DEBUG " -Og")
string(APPEND CMAKE_CXX_FLAGS_DEBUG " -Og")
if("${USE_COVERAGE}")
  if(NOT "${CMAKE_C_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
    message(FATAL_ERROR "USE_COVERAGE was on but CC isn't clang")
  endif()
  if(NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
    message(FATAL_ERROR "USE_COVERAGE was on but CXX isn't clang++")
  endif()
  # FIXME requires clang11+
  string(APPEND CMAKE_C_FLAGS_DEBUG " --coverage -fprofile-instr-generate -fcoverage-mapping")
  string(APPEND CMAKE_CXX_FLAGS_DEBUG " --coverage -fprofile-instr-generate -fcoverage-mapping")
endif()

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
set(PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
elseif(APPLE)
# surely there's a better way to do this? alas, seems necessary to pull the
# pkg-config files out of Homebrew.
if(NOT DEFINED ENV{PKG_CONFIG_PATH})
set(ENV{PKG_CONFIG_PATH} "/usr/local/opt/ncurses/lib/pkgconfig:/usr/local/opt/readline/lib/pkgconfig")
endif()
set(PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
else()
set(PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/libdata/pkgconfig")
endif()

# global compiler flags
add_compile_definitions(_FORTIFY_SOURCE=2)
add_compile_options(-Wall -Wextra -W -Wshadow -Wformat -Wformat-security
                    -fexceptions -fstrict-aliasing)

message(STATUS "Requested multimedia engine: ${USE_MULTIMEDIA}")
message(STATUS "Requested build mode: ${CMAKE_BUILD_TYPE}")

find_package(PkgConfig REQUIRED)
# don't use REQUIRED with subsequent find_package() operations; we use
# feature_summary + set_package_properties to fail in one fell swoop.
find_package(Threads)
set_package_properties(Threads PROPERTIES TYPE REQUIRED)
find_package(ZLIB)
set_package_properties(ZLIB PROPERTIES TYPE REQUIRED)
# platform-specific logics
if(MSYS OR WIN32)
  set(LIBRT_LIBRARIES wsock32 ws2_32)
elseif(NOT APPLE)
  find_library(LIBM m REQUIRED)
  find_library(LIBRT rt REQUIRED)
endif()
if(NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  include_directories(/usr/local/include)
  link_directories(/usr/local/lib)
  set(CMAKE_REQUIRED_INCLUDES /usr/local/include)
endif()
# some distros (<cough>motherfucking alpine</cough> subsume terminfo directly
# into ncurses. accept either, and may god have mercy on our souls.
pkg_search_module(TERMINFO REQUIRED tinfo>=6.1 ncursesw>=6.1)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND terminfo)
set_package_properties(terminfo PROPERTIES TYPE REQUIRED)
set(PKGCONF_REQ_PRIV "${TERMINFO_LIBRARIES}")
if(${USE_READLINE})
pkg_search_module(READLINE REQUIRED readline>=8.0)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND readline)
set_package_properties(readline PROPERTIES TYPE REQUIRED)
endif()
if(${USE_FFMPEG})
pkg_check_modules(AVCODEC REQUIRED libavcodec>=57.0)
pkg_check_modules(AVFORMAT REQUIRED libavformat>=57.0)
pkg_check_modules(AVUTIL REQUIRED libavutil>=56.0)
pkg_check_modules(SWSCALE REQUIRED libswscale>=5.0)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND FFMpeg)
elseif(${USE_OIIO})
pkg_check_modules(OIIO REQUIRED OpenImageIO>=2.1)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND OpenImageIO)
endif()

if(${USE_DOCTEST})
find_package(doctest 2.3.5)
set_package_properties(doctest PROPERTIES TYPE REQUIRED)
endif()

# don't cache these, or installing them requires clearing the cache to be found.
# this is going to be true for anything lacking pkg-config/CMake support.
# unigbrk.h was introduced in libunistring 0.9.4, 2010-02-14.
unset(HAVE_UNISTRING_H CACHE)
check_include_file("unigbrk.h" HAVE_UNISTRING_H)
if(NOT "${HAVE_UNISTRING_H}")
  message(FATAL_ERROR "Couldn't find unigbrk.h from GNU libunistring")
endif()
find_library(unistring unistring REQUIRED)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND libunistring)
set_package_properties(libunistring PROPERTIES TYPE REQUIRED)
unset(HAVE_QRCODEGEN_H CACHE)
if("${USE_QRCODEGEN}")
check_include_file("qrcodegen/qrcodegen.h" HAVE_QRCODEGEN_H)
if(NOT "${HAVE_QRCODEGEN_H}")
  message(FATAL_ERROR "USE_QRCODEGEN is active, but couldn't find qrcodegen.h")
endif()
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND qrcodegen)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

file(GLOB COMPATSRC CONFIGURE_DEPENDS src/compat/compat.c)

############################################################################
# libnotcurses-core (core shared library, core static library)
file(GLOB NCCORESRCS CONFIGURE_DEPENDS src/lib/*.c src/lib/*.cpp)
add_library(notcurses-core SHARED ${NCCORESRCS} ${COMPATSRC})
if(${USE_STATIC})
add_library(notcurses-core-static STATIC ${NCCORESRCS})
else()
add_library(notcurses-core-static STATIC EXCLUDE_FROM_ALL ${NCCORESRCS})
endif()
# don't want these on freebsd/dragonfly/osx
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
target_compile_definitions(notcurses-core
  PUBLIC
   _XOPEN_SOURCE=700 # wcwidth(3) requires _XOPEN_SOURCE, and is in our headers
  PRIVATE
   _GNU_SOURCE _DEFAULT_SOURCE
)
target_compile_definitions(notcurses-core-static
  PUBLIC
   _XOPEN_SOURCE=700 # wcwidth(3) requires _XOPEN_SOURCE, and is in our headers
  PRIVATE
   _GNU_SOURCE _DEFAULT_SOURCE
)
endif()
set_target_properties(notcurses-core PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
)
set_target_properties(notcurses-core-static PROPERTIES
  VERSION ${PROJECT_VERSION}
  OUTPUT_NAME notcurses-core
)
target_include_directories(notcurses-core
  PRIVATE
    include
    src
    "${CMAKE_REQUIRED_INCLUDES}"
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_INCLUDE_DIRS}"
    "${ZLIB_INCLUDE_DIRS}"
)
target_include_directories(notcurses-core-static
  PRIVATE
    include
    src
    "${CMAKE_REQUIRED_INCLUDES}"
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_STATIC_INCLUDE_DIRS}"
    "${ZLIB_STATIC_INCLUDE_DIRS}"
)
target_link_libraries(notcurses-core
  PRIVATE
    "${ZLIB_LIBRARIES}"
    "${TERMINFO_LIBRARIES}"
    "${LIBM}"
    "${LIBRT_LIBRARIES}"
    "${unistring}"
  PUBLIC
    Threads::Threads
)
target_link_libraries(notcurses-core-static
  PRIVATE
    "${ZLIB_STATIC_LIBRARIES}"
    "${TERMINFO_STATIC_LIBRARIES}"
    "${LIBM}"
    "${LIBRT_LIBRARIES}"
    "${unistring}"
  PUBLIC
    Threads::Threads
)
target_link_directories(notcurses-core
  PRIVATE
    "${TERMINFO_LIBRARY_DIRS}"
    "${ZLIB_LIBRARY_DIRS}"
)
target_link_directories(notcurses-core-static
  PRIVATE
    "${TERMINFO_STATIC_LIBRARY_DIRS}"
    "${ZLIB_STATIC_LIBRARY_DIRS}"
)
if(${USE_QRCODEGEN})
target_link_libraries(notcurses-core PRIVATE qrcodegen)
target_link_libraries(notcurses-core-static PRIVATE qrcodegen)
endif()

############################################################################
# libnotcurses (multimedia shared library+static library)
file(GLOB NCSRCS CONFIGURE_DEPENDS src/media/*.c src/media/*.cpp)
add_library(notcurses SHARED ${NCSRCS} ${COMPATSRC})
if(${USE_STATIC})
add_library(notcurses-static STATIC ${NCSRCS})
else()
add_library(notcurses-static STATIC EXCLUDE_FROM_ALL ${NCSRCS})
endif()
set_target_properties(notcurses PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
)
set_target_properties(notcurses-static PROPERTIES
  VERSION ${PROJECT_VERSION}
  OUTPUT_NAME notcurses
)
target_include_directories(notcurses
  PRIVATE
    include
    src
    src/lib
    "${CMAKE_REQUIRED_INCLUDES}"
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_INCLUDE_DIRS}"
)
target_include_directories(notcurses-static
  PRIVATE
    include
    src
    src/lib
    "${CMAKE_REQUIRED_INCLUDES}"
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_INCLUDE_DIRS}"
)
target_link_libraries(notcurses
  PUBLIC
    notcurses-core
)
target_link_libraries(notcurses-static
  PUBLIC
    notcurses-core-static
)
if(${USE_READLINE})
target_link_libraries(notcurses-core
  PUBLIC
    "${READLINE_LIBRARIES}"
)
target_link_directories(notcurses-core
  PUBLIC
    "${READLINE_LIBRARY_DIRS}"
)
target_link_libraries(notcurses-core-static
  PUBLIC
    "${READLINE_LIBRARIES}"
)
target_link_directories(notcurses-core-static
  PUBLIC
    "${READLINE_LIBRARY_DIRS}"
)
endif()
if(${USE_FFMPEG})
target_include_directories(notcurses
  PRIVATE
    "${AVCODEC_INCLUDE_DIRS}"
    "${AVFORMAT_INCLUDE_DIRS}"
    "${AVUTIL_INCLUDE_DIRS}"
    "${SWSCALE_INCLUDE_DIRS}"
)
target_include_directories(notcurses-static
  PRIVATE
    "${AVCODEC_STATIC_INCLUDE_DIRS}"
    "${AVFORMAT_STATIC_INCLUDE_DIRS}"
    "${AVUTIL_STATIC_INCLUDE_DIRS}"
    "${SWSCALE_STATIC_INCLUDE_DIRS}"
)
target_link_libraries(notcurses
  PRIVATE
    "${AVCODEC_LIBRARIES}"
    "${AVFORMAT_LIBRARIES}"
    "${SWSCALE_LIBRARIES}"
    "${AVUTIL_LIBRARIES}"
)
target_link_libraries(notcurses-static
  PRIVATE
    "${AVCODEC_STATIC_LIBRARIES}"
    "${AVFORMAT_STATIC_LIBRARIES}"
    "${SWSCALE_STATIC_LIBRARIES}"
    "${AVUTIL_STATIC_LIBRARIES}"
)
target_link_directories(notcurses
  PRIVATE
    "${AVCODEC_LIBRARY_DIRS}"
    "${AVFORMAT_LIBRARY_DIRS}"
    "${SWSCALE_LIBRARY_DIRS}"
    "${AVUTIL_LIBRARY_DIRS}"
)
target_link_directories(notcurses-static
  PRIVATE
    "${AVCODEC_STATIC_LIBRARY_DIRS}"
    "${AVFORMAT_STATIC_LIBRARY_DIRS}"
    "${SWSCALE_STATIC_LIBRARY_DIRS}"
    "${AVUTIL_STATIC_LIBRARY_DIRS}"
)
elseif(${USE_OIIO})
target_include_directories(notcurses PUBLIC "${OIIO_INCLUDE_DIRS}")
target_include_directories(notcurses-static PUBLIC "${OIIO_STATIC_INCLUDE_DIRS}")
target_link_libraries(notcurses PRIVATE ${OIIO_LIBRARIES})
target_link_libraries(notcurses-static PRIVATE ${OIIO_STATIC_LIBRARIES})
target_link_directories(notcurses PRIVATE ${OIIO_LIBRARY_DIRS})
target_link_directories(notcurses-static PRIVATE ${OIIO_STATIC_LIBRARY_DIRS})
endif()

############################################################################
# libnotcurses++ (C++ wrappers)
set(NCPP_SOURCES
  src/libcpp/FDPlane.cc
  src/libcpp/Menu.cc
  src/libcpp/MultiSelector.cc
  src/libcpp/NotCurses.cc
  src/libcpp/Plane.cc
  src/libcpp/Plot.cc
  src/libcpp/Reel.cc
  src/libcpp/Root.cc
  src/libcpp/Selector.cc

=== debian/changelog ===
notcurses (2.3.13+dfsg.1-1) unstable; urgency=medium

  * New upstream, fixes in intro, fission, and uniblock demos for small
    geometries. Properly detect pixel geometry in Docker.

 -- Nick Black <dankamongmen@gmail.com>  Wed, 04 Aug 2021 23:41:51 -0400

notcurses (2.3.12+dfsg.1-1) unstable; urgency=medium

  * New upstream 2.3.12 with many bugfixes plus support for Type-1
    DVB subtitles.

 -- Nick Black <dankamongmen@gmail.com>  Thu, 29 Jul 2021 01:01:51 -0400

notcurses (2.3.11+dfsg.1-1) unstable; urgency=medium

  * New upstream 2.3.11

 -- Nick Black <dankamongmen@gmail.com>  Tue, 20 Jul 2021 14:18:26 -0400

notcurses (2.3.8+dfsg.1-1) unstable; urgency=medium

  * New upstream 2.3.8, bugfix release

 -- Nick Black <dankamongmen@gmail.com>  Sun, 04 Jul 2021 01:24:12 -0400

notcurses (2.3.7+dfsg.1-1) unstable; urgency=medium

  * New upstream 2.3.7

 -- Nick Black <dankamongmen@gmail.com>  Tue, 29 Jun 2021 07:13:50 -0400

notcurses (2.3.6+dfsg.1-1) unstable; urgency=medium

  * New upstream 2.3.6, drop all outstanding patches

 -- Nick Black <dankamongmen@gmail.com>  Wed, 23 Jun 2021 22:38:20 -0400

notcurses (2.3.5+dfsg.1-1) unstable; urgency=medium

  * New upstream 2.3.5

 -- Nick Black <dankamongmen@gmail.com>  Wed, 23 Jun 2021 13:35:01 -0400

notcurses (2.3.4+dfsg.1-4) unstable; urgency=medium

  * Mark demotest as flaky until 2.3.5 fixes it.

 -- Nick Black <dankamongmen@gmail.com>  Sat, 19 Jun 2021 00:44:00 -0400

notcurses (2.3.4+dfsg.1-3) unstable; urgency=medium

  * Fix autopkg test to use -m0,2,0,2 instead of -m2, as the
    autopkgtests on the Ubuntu build infrastructure are running
    in 80x24. Thanks Robert Ancell (robert.ancell@ubuntu.com)!

 -- Nick Black <dankamongmen@gmail.com>  Sat, 19 Jun 2021 00:43:55 -0400

notcurses (2.3.4+dfsg.1-2) unstable; urgency=medium

  * Upload to unstable now that freeze is almost upon us.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 13 Jun 2021 17:15:02 -0400

notcurses (2.3.4+dfsg.1-1) experimental; urgency=medium

  * New upstream version, including nctabbed and Kitty bitmaps.
  * New binary 'notcurses-info'

 -- Nick Black <dankamongmen@gmail.com>  Sat, 12 Jun 2021 17:29:36 -0400

=== debian/control ===
Source: notcurses
Priority: optional
Maintainer: Nick Black <dankamongmen@gmail.com>
Build-Depends:
 cmake (>= 3.14),
 debhelper-compat (= 13),
 dh-python (>= 4.20191017),
 dh-sequence-python3,
 doctest-dev,
 libavformat-dev (>= 7:4.2.1),
 libavutil-dev (>= 7:4.2.1),
 libncurses-dev,
 libqrcodegen-dev (>= 1.5.0),
 libreadline-dev,
 libswscale-dev (>= 7:4.2.1),
 libunistring-dev,
 pandoc (>= 1.19.2.4),
 pkg-config,
 python3-cffi (>= 1.13.2),
 python3-dev,
 python3-pip (>= 20.0),
 python3-pypandoc,
 python3-setuptools (>= 44.0.0),
 zlib1g-dev,
Standards-Version: 4.5.1
Section: libs
X-Python3-Version: >= 3.7
Rules-Requires-Root: no
Homepage: https://nick-black.com/dankwiki/index.php/Notcurses
Vcs-Browser: https://salsa.debian.org/debian/notcurses
Vcs-Git: https://salsa.debian.org/debian/notcurses.git

Package: libnotcurses++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnotcurses++2 (= ${binary:Version}),
 libnotcurses-dev (>= ${binary:Version}),
 ${misc:Depends},
Description: Character graphics and TUI library (C++ development)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files are necessary for C++ development using Notcurses.

Package: libnotcurses++2
Architecture: any
Multi-Arch: same
Recommends:
 ncurses-term,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 libnotcurses++1 (>= 2),
Breaks:
 libnotcurses++1 (>= 2),
Description: Character graphics and TUI library (C++)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.

Package: libnotcurses-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnotcurses-core2 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 libnotcurses-dev,
Replaces:
 libnotcurses-dev (<< 2.1.7),
Breaks:
 libnotcurses-dev (<< 2.1.7),
Description: Character graphics and TUI library (core development)
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. This development
 package covers the Notcurses core library.
 .
 These files are necessary for C development using Notcurses. They
 do not include multimedia support; that requires libnotcurses-dev.

Package: libnotcurses-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnotcurses-core-dev (>= ${binary:Version}),
 libnotcurses2 (= ${binary:Version}),
 ${misc:Depends},
Description: Character graphics and TUI library (development)
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 These files are necessary for C development using Notcurses. This
 package installs multimedia support atop libnotcurses-core-dev.

Package: libnotcurses-core2
Architecture: any
Multi-Arch: same
Recommends:
 libnotcurses2,
 ncurses-term,
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 libnotcurses1 (>= 2),
 libnotcurses2 (<< 2.1.7),
Breaks:
 libnotcurses1 (>= 2),
 libnotcurses2 (<< 2.1.7),
Description: Character graphics and TUI library (core)
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor.
 .
 This core library lacks multimedia support. For that,
 libnotcurses2 must be installed.

Package: libnotcurses2
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 libnotcurses1 (>= 2),
Breaks:
 libnotcurses1 (>= 2),
Description: Character graphics and TUI library
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 This package provides multimedia support via ffmpeg.

Package: notcurses-bin
Architecture: any
Multi-Arch: foreign
Section: graphics
Depends:
 notcurses-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 desktop-base,
 ncurses-term,
 python3-notcurses (>= ${source:Version}),
Description: Character graphics and TUI library demos
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These utilities from the Notcurses project include notcurses-demo
 (a demonstration of various libnotcurses capabilities), ncplayer
 (a character mode multimedia player), ncls (a file lister that
 displays multimedia), and other tools. Unit tests are furthermore
 bundled as notcurses-tester.

Package: notcurses-data
Architecture: all
Multi-Arch: foreign
Section: graphics
Depends:
 ${misc:Depends},
Recommends:
 ncurses-term,
Description: Multimedia used by notcurses-bin
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 This package contains multimedia used by notcurses-demo
 and notcurses-tester from the notcurses-bin package.

Package: python3-notcurses
Section: python
Architecture: any
Multi-Arch: no
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
Replaces:
 notcurses-bin (<< 1.6),
Breaks:
 notcurses-bin (<< 1.6),
Description: Character graphics and TUI library (Python)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files are necessary for Python development using Notcurses.
 The notcurses-pydemo script verifies these Python wrappers.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_BUILD_MAINT_OPTIONS=reproducible=+fixfilepath

export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+fixfilepath
export PYBUILD_NAME=notcurses
export PYBUILD_DIR=cffi
export PYBUILD_DESTDIR=debian/python3-notcurses

CFLAGS += -ffile-prefix-map=$(CURDIR)=.

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DDFSG_BUILD=on -DUSE_POC=off -DUSE_QRCODEGEN=on

override_dh_auto_build:
	dh_auto_build
	CFLAGS="$(CFLAGS) -I$(CURDIR)/include" LDFLAGS="$(LDFLAGS) \
		-L$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)" pybuild --build

override_dh_auto_install:
	dh_auto_install -B $(BUILDDIR)
	pybuild --install

=== debian/tests/control ===
# The CI pipeline on salsa.debian.org doesn't appear to export a TERM variable
# to the autopkgtest environment. We thus manually use TERM=xterm-256color for all
# commands. They'd otherwise fail out, or (worse) not actually test anything.

# Connects to and queries the controlling terminal, dumping info
Test-Command: TERM=xterm-256color notcurses-info
Depends: notcurses-bin
Restrictions: allow-stderr
Features: test-name=info

# Basic unit test suite, but run with installed binary
# redirect to /dev/null to not overwhelm builder logging
Test-Command: TERM=xterm-256color notcurses-tester > /dev/null
Depends: notcurses-bin
Restrictions: allow-stderr
Features: test-name=unittests

# Execute notcurses-pydemo
Test-Command: TERM=xterm-256color notcurses-pydemo
Depends: python3-notcurses
Restrictions: allow-stderr
Features: test-name=pydemo

## notcurses 3.0.6+dfsg.1

=== CMakeLists.txt ===
# 3.14.0 introduced NAME_WLE
cmake_minimum_required(VERSION 3.14.0)
project(notcurses VERSION 3.0.6
  DESCRIPTION "Blingful UI for modern terminal emulators"
  HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
  LANGUAGES C)
include(CTest)
include(GNUInstallDirs)
include(CMakeDependentOption)
include(FeatureSummary)

###################### USER-SELECTABLE OPTIONS ###########################
# BUILD_TESTING is defined by CTest
option(DFSG_BUILD "DFSG build (no non-free media/code)" OFF)
option(USE_ASAN "Build with AddressSanitizer" OFF)
option(USE_COVERAGE "Assess code coverage with llvm-cov/lcov" OFF)
option(USE_CXX "Build C++ code" ON)
cmake_dependent_option(
  USE_DOCTEST "Build notcurses-tester with doctest" ON
  "BUILD_TESTING;USE_CXX" OFF
)
option(USE_DEFLATE "Use libdeflate instead of libz" ON)
option(USE_DOXYGEN "Build HTML cross reference with doxygen" OFF)
option(USE_GPM "Enable libgpm console mouse support" OFF)
option(USE_PANDOC "Build man pages and HTML reference with pandoc" ON)
option(BUILD_EXECUTABLES "Build executables" ON)
option(BUILD_FFI_LIBRARY "Build ffi library (containing all symbols which are static inline)" ON)
option(USE_POC "Build small, uninstalled proof-of-concept binaries" ON)
option(USE_QRCODEGEN "Enable libqrcodegen QR code support" OFF)
option(USE_STATIC "Build static libraries (in addition to shared)" ON)
set(USE_MULTIMEDIA "ffmpeg" CACHE STRING "Multimedia engine, one of 'ffmpeg', 'oiio', or 'none'")
set_property(CACHE USE_MULTIMEDIA PROPERTY STRINGS ffmpeg oiio none)
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE
    STRING "Choose the build mode." FORCE)
endif()
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release MinSizeRel RelWithDebInfo Coverage)
############## END (additional) USER-SELECTABLE OPTIONS ##################
set(USE_FFMPEG OFF)
set(USE_OIIO OFF)
if(${USE_MULTIMEDIA} STREQUAL "ffmpeg")
  set(USE_FFMPEG ON)
elseif(${USE_MULTIMEDIA} STREQUAL "oiio")
  if(NOT ${USE_CXX})
    message(FATAL_ERROR "USE_CXX must be on to use OpenImageIO.")
  endif()
  set(USE_OIIO ON)
elseif(NOT ${USE_MULTIMEDIA} STREQUAL "none")
  message(FATAL_ERROR "USE_MULTIMEDIA must be one of 'oiio', 'ffmpeg', 'none' (was '${USE_MULTIMEDIA}').")
endif()
if (NOT BUILD_EXECUTABLES AND USE_POC)
  message(WARNING "Disabling USE_POC since BUILD_EXECUTABLES=OFF")
  set(USE_POC OFF)
endif()

if(${USE_CXX})
  enable_language(CXX)
endif()
if(${USE_CXX})
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
string(APPEND CMAKE_CXX_FLAGS_DEBUG " -Og")
endif()
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_VISIBILITY_PRESET hidden)

message(STATUS "Requested multimedia engine: ${USE_MULTIMEDIA}")
message(STATUS "Requested build mode: ${CMAKE_BUILD_TYPE}")

string(APPEND CMAKE_C_FLAGS_DEBUG " -Og")
if(${USE_COVERAGE})
  if(NOT "${CMAKE_C_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
    message(FATAL_ERROR "USE_COVERAGE was on but CC isn't clang")
  endif()
  # FIXME requires clang11+
  string(APPEND CMAKE_C_FLAGS_DEBUG " --coverage -fprofile-instr-generate -fcoverage-mapping")
  if(${USE_CXX})
    if(NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
      message(FATAL_ERROR "USE_COVERAGE was on but CXX isn't clang++")
    endif()
    string(APPEND CMAKE_CXX_FLAGS_DEBUG " --coverage -fprofile-instr-generate -fcoverage-mapping")
  endif()
endif()

# under msys2 (and all other operating systems) we want pkgconfig. when
# building with visual studio, don't require it.
if(NOT MSVC)
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
set(PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
elseif(APPLE)
# surely there's a better way to do this? alas, seems necessary to pull the
# pkg-config files out of Homebrew.
if(NOT DEFINED ENV{PKG_CONFIG_PATH})
set(ENV{PKG_CONFIG_PATH} "/usr/local/opt/ncurses/lib/pkgconfig")
endif()
set(PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
else()
set(PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/libdata/pkgconfig")
endif()
find_package(PkgConfig REQUIRED)
# some distros (<cough>motherfucking alpine</cough> subsume terminfo directly
# into ncurses. accept either, and may god have mercy on our souls.
pkg_search_module(TERMINFO REQUIRED tinfo>=6.1 ncursesw>=6.1)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND terminfo)
set_package_properties(terminfo PROPERTIES TYPE REQUIRED)
set(PKGCONF_REQ_PRIV "${TERMINFO_LIBRARIES}")
if(${USE_FFMPEG})
pkg_check_modules(AVCODEC REQUIRED libavcodec>=57.0)
pkg_check_modules(AVFORMAT REQUIRED libavformat>=57.0)
pkg_check_modules(AVUTIL REQUIRED libavutil>=56.0)
pkg_check_modules(SWSCALE REQUIRED libswscale>=5.0)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND FFMpeg)
elseif(${USE_OIIO})
find_package(OpenImageIO 2.1 REQUIRED)
endif()
endif()

# global compiler flags
if(NOT WIN32)
# MSYS2 needs -lssp and -fstack-protector for _FORTIFY_SOURCE
# macOS with ASAN can't handle _FORTIFY_SOURCE != 1
if(NOT ${USE_ASAN})
add_compile_definitions(_FORTIFY_SOURCE=2)
endif()
add_compile_options(-Wformat -Werror=format-security)
endif()
if(MSVC)
add_compile_options(/W4)
else()
add_compile_options(-Wall -Wextra -W -Wshadow -Wvla)
# -ffast-math dies on NaNs we draw from libav (by -ffinite-math-only)
add_compile_options(-fno-signed-zeros -fno-trapping-math -fassociative-math)
add_compile_options(-fno-math-errno -freciprocal-math -funsafe-math-optimizations)
add_compile_options(-fexceptions -fstrict-aliasing)
if(${USE_ASAN})
add_compile_options(-fsanitize=address)
add_link_options(-fsanitize=address)
endif()
endif()

# don't use REQUIRED with subsequent find_package() operations; we use
# feature_summary + set_package_properties to fail in one fell swoop.
find_package(Threads)
set_package_properties(Threads PROPERTIES TYPE REQUIRED)
# platform-specific logics
if(WIN32)
  set(LIBRT wsock32 ws2_32 secur32)
elseif(NOT APPLE)
  find_library(LIBM m REQUIRED)
  find_library(LIBRT rt REQUIRED)
endif()
if(NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  include_directories(/usr/local/include)
  link_directories(/usr/local/lib)
  set(CMAKE_REQUIRED_INCLUDES /usr/local/include)
endif()

if(${USE_DOCTEST})
find_package(doctest 2.3.5)
set_package_properties(doctest PROPERTIES TYPE REQUIRED)
endif()

# don't cache these, or installing them requires clearing the cache to be found.
# this is going to be true for anything lacking pkg-config/CMake support.
# unigbrk.h was introduced in libunistring 0.9.4, 2010-02-14.
unset(HAVE_UNISTRING_H CACHE)
check_include_file("unigbrk.h" HAVE_UNISTRING_H)
if(NOT "${HAVE_UNISTRING_H}")
  message(FATAL_ERROR "Couldn't find unigbrk.h from GNU libunistring")
endif()
find_library(unistring unistring REQUIRED)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND libunistring)
set_package_properties(libunistring PROPERTIES TYPE REQUIRED)

# optional dependencies lacking pkg-config support
if(${USE_DEFLATE})
unset(HAVE_DEFLATE_H CACHE)
check_include_file("libdeflate.h" HAVE_DEFLATE_H)
if(NOT "${HAVE_DEFLATE_H}")
  message(FATAL_ERROR "Couldn't find libdeflate.h")
endif()
find_library(libdeflate deflate REQUIRED)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND libdeflate)
set_package_properties(libdeflate PROPERTIES TYPE REQUIRED)
else()
find_package(ZLIB)
set_package_properties(ZLIB PROPERTIES TYPE REQUIRED)
endif()

if(${USE_GPM}) # no pkgconfig from gpm
unset(HAVE_GPM_H CACHE)
check_include_file("gpm.h" HAVE_GPM_H)
if(NOT "${HAVE_GPM_H}")
  message(FATAL_ERROR "Couldn't find gpm.h from libgpm")
endif()
find_library(gpm gpm REQUIRED)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND libgpm)
set_package_properties(libgpm PROPERTIES TYPE REQUIRED)
endif()

if("${USE_QRCODEGEN}")
unset(HAVE_QRCODEGEN_H CACHE)
check_include_file("qrcodegen/qrcodegen.h" HAVE_QRCODEGEN_H)
if(NOT "${HAVE_QRCODEGEN_H}")
  message(FATAL_ERROR "USE_QRCODEGEN is active, but couldn't find qrcodegen.h")
endif()
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND qrcodegen)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

file(GLOB COMPATSRC CONFIGURE_DEPENDS src/compat/*.c)

############################################################################
# libnotcurses-core (core shared library, core static library)
file(GLOB NCCORESRCS CONFIGURE_DEPENDS src/lib/*.c)
add_library(notcurses-core SHARED ${NCCORESRCS} ${COMPATSRC})
if(${USE_STATIC})
add_library(notcurses-core-static STATIC ${NCCORESRCS} ${COMPATSRC})
else()
add_library(notcurses-core-static STATIC EXCLUDE_FROM_ALL ${NCCORESRCS} ${COMPATSRC})
endif()
# don't want these on freebsd/dragonfly/osx
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
target_compile_definitions(notcurses-core
  PUBLIC
   _XOPEN_SOURCE=700 # wcwidth(3) requires _XOPEN_SOURCE, and is in our headers
  PRIVATE
   _GNU_SOURCE _DEFAULT_SOURCE
)
target_compile_definitions(notcurses-core-static
  PUBLIC
   _XOPEN_SOURCE=700 # wcwidth(3) requires _XOPEN_SOURCE, and is in our headers
  PRIVATE
   _GNU_SOURCE _DEFAULT_SOURCE
)
endif()
set_target_properties(notcurses-core PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
)
set_target_properties(notcurses-core-static PROPERTIES
  VERSION ${PROJECT_VERSION}
  OUTPUT_NAME notcurses-core
)
target_include_directories(notcurses-core
  BEFORE
  PRIVATE
    include
    src
    "${CMAKE_REQUIRED_INCLUDES}"
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_INCLUDE_DIRS}"
    "${libdeflate_INCLUDE_DIRS}"
    "${ZLIB_INCLUDE_DIRS}"
)
target_include_directories(notcurses-core-static
  BEFORE
  PRIVATE
    include
    src
    "${CMAKE_REQUIRED_INCLUDES}"
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_STATIC_INCLUDE_DIRS}"
    "${libdeflate_STATIC_INCLUDE_DIRS}"
    "${ZLIB_STATIC_INCLUDE_DIRS}"
)
target_link_libraries(notcurses-core
  PRIVATE
    "${libdeflate}"
    "${ZLIB_LIBRARIES}"
    "${TERMINFO_LIBRARIES}"
    "${LIBM}"
    "${unistring}"
    "${gpm}"
  PUBLIC
    Threads::Threads
    "${LIBRT}"
)
target_link_libraries(notcurses-core-static
  PRIVATE
    "${libdeflate_STATIC_LIBRARIES}"
    "${ZLIB_STATIC_LIBRARIES}"
    "${TERMINFO_STATIC_LIBRARIES}"
    "${LIBM}"
    "${unistring}"
    "${gpm}"
    Threads::Threads
    "${LIBRT}"
)
target_link_directories(notcurses-core
  PRIVATE
    "${TERMINFO_LIBRARY_DIRS}"
    "${libdeflate_LIBRARY_DIRS}"
    "${ZLIB_LIBRARY_DIRS}"
)
target_link_directories(notcurses-core-static
  PRIVATE
    "${TERMINFO_STATIC_LIBRARY_DIRS}"
    "${libdeflate_STATIC_LIBRARY_DIRS}"
    "${ZLIB_STATIC_LIBRARY_DIRS}"
)
if(${USE_QRCODEGEN})
target_link_libraries(notcurses-core PRIVATE qrcodegen)
target_link_libraries(notcurses-core-static PRIVATE qrcodegen)
endif()

############################################################################
# libnotcurses (multimedia shared library+static library)
file(GLOB NCSRCS CONFIGURE_DEPENDS src/media/*.c src/media/*.cpp)
add_library(notcurses SHARED ${NCSRCS} ${COMPATSRC})
if(${USE_STATIC})
add_library(notcurses-static STATIC ${NCSRCS} ${COMPATSRC})
else()
add_library(notcurses-static STATIC EXCLUDE_FROM_ALL ${NCSRCS} ${COMPATSRC})
endif()
set_target_properties(notcurses PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
)
set_target_properties(notcurses-static PROPERTIES
  VERSION ${PROJECT_VERSION}
  OUTPUT_NAME notcurses
)
target_include_directories(notcurses
  BEFORE
  PRIVATE
    include
    src
    "${CMAKE_REQUIRED_INCLUDES}"
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_INCLUDE_DIRS}"
)
target_include_directories(notcurses-static
  BEFORE
  PRIVATE
    include
    src
    "${CMAKE_REQUIRED_INCLUDES}"
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_INCLUDE_DIRS}"
)
target_compile_definitions(notcurses
  PRIVATE
   _GNU_SOURCE _DEFAULT_SOURCE
)
target_compile_definitions(notcurses-static
  PRIVATE
   _GNU_SOURCE _DEFAULT_SOURCE
)
target_link_libraries(notcurses
  PUBLIC
    notcurses-core
)
target_link_libraries(notcurses-static
  PUBLIC
    notcurses-core-static
)
if(${USE_FFMPEG})

=== debian/changelog ===
notcurses (3.0.6+dfsg.1-1) unstable; urgency=medium

  * New upstream release.

 -- Nick Black <dankamongmen@gmail.com>  Wed, 09 Feb 2022 22:40:45 -0500

notcurses (3.0.5+dfsg.1-1) unstable; urgency=medium

  * New upstream, drop all patches.

 -- Nick Black <dankamongmen@gmail.com>  Fri, 21 Jan 2022 12:41:19 -0500

notcurses (3.0.4+dfsg.1-2) unstable; urgency=medium

  * Apply patch consisting of 3.0.5 input material in the never-
    ending quest to resolve the growlight autopkgtests.

 -- Nick Black <dankamongmen@gmail.com>  Sat, 15 Jan 2022 13:52:50 -0500

notcurses (3.0.4+dfsg.1-1) unstable; urgency=medium

  * New upstream version. Drop all patches.

 -- Nick Black <dankamongmen@gmail.com>  Sat, 08 Jan 2022 14:52:47 -0500

notcurses (3.0.3+dfsg.1-3) unstable; urgency=medium

  * Apply patches from upstream causing -DBUILD_FFI_LIBRARY=off to
    actually take effect. (Closes: #1003009) for real this time =\.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 02 Jan 2022 19:39:06 -0500

notcurses (3.0.3+dfsg.1-2) unstable; urgency=medium

  * Supply -DBUILD_FFI_LIBRARY=off (Closes: #1003009).

 -- Nick Black <dankamongmen@gmail.com>  Sun, 02 Jan 2022 18:15:16 -0500

notcurses (3.0.3+dfsg.1-1) unstable; urgency=medium

  * New upstream release. Drop all patches.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 02 Jan 2022 12:33:14 -0500

notcurses (3.0.2+dfsg.1-3) unstable; urgency=medium

  * Apply fix-box-demo.patch from upstream to resolve "demo" autopkgtest.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 26 Dec 2021 00:28:57 -0500

notcurses (3.0.2+dfsg.1-2) unstable; urgency=medium

  * Take demo autopkgtest to loglevel 3 to run down failures.

 -- Nick Black <dankamongmen@gmail.com>  Sat, 25 Dec 2021 19:26:19 -0500

notcurses (3.0.2+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Install new tfman binary.

 -- Nick Black <dankamongmen@gmail.com>  Tue, 21 Dec 2021 09:03:17 -0500

notcurses (3.0.1+dfsg.1-1) unstable; urgency=medium

  * New upstream release.
  * Move to unstable from experimental.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 12 Dec 2021 15:12:44 -0500

notcurses (3.0.0+dfsg.1-1) experimental; urgency=medium

  * New upstream release, new SONAME 3. Rename library packages.
  * Drop zlib1-dev depend, add libdeflate-dev.
  * Drop unnecessary Breaks/Replaces (thanks sramacher!).

 -- Nick Black <dankamongmen@gmail.com>  Wed, 08 Dec 2021 06:51:19 -0500

notcurses (2.4.9+dfsg.1-1) unstable; urgency=medium

  * New upstream release.

 -- Nick Black <dankamongmen@gmail.com>  Thu, 11 Nov 2021 08:12:03 -0500

notcurses (2.4.8+dfsg.1-1) unstable; urgency=medium

  * New upstream release, update symbols file.

 -- Nick Black <dankamongmen@gmail.com>  Sat, 23 Oct 2021 06:37:45 -0400

notcurses (2.4.7+dfsg.1-2) unstable; urgency=medium

  * Add ncvisual_blit to symbols.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 17 Oct 2021 16:21:42 -0400

notcurses (2.4.7+dfsg.1-1) unstable; urgency=medium

  * New upstream release.

 -- Nick Black <dankamongmen@gmail.com>  Sat, 16 Oct 2021 23:57:28 -0400

notcurses (2.4.5+dfsg.1-1) unstable; urgency=medium

  * New upstream release, update symbols file.
  * ncplane_boundlist() has been removed upstream without a new
    ABI name, but this function was introduced recently, never
    documented, and believed not to have been used externally.

 -- Nick Black <dankamongmen@gmail.com>  Thu, 07 Oct 2021 04:45:05 -0400

notcurses (2.4.4+dfsg.1-3) unstable; urgency=medium

  * New upstream release. Drop libreadline-dev dep.
  * Drop libnotcurses++2 symbols file due to C++ disease (retain others).

 -- Nick Black <dankamongmen@gmail.com>  Sun, 03 Oct 2021 00:42:14 -0400

notcurses (2.4.3+dfsg.1-1) unstable; urgency=medium

  * New upstream release, updated for recent changes to DECSDM semantics in
    XTerm 369 and other terminals.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 26 Sep 2021 12:45:03 -0400

notcurses (2.4.2+dfsg.1-3) unstable; urgency=medium

  * Disable "notcurses-demo" test, which is failing on armhf and not
    yielding any workable logs. We'll want to restore this once we
    figure out what's going on.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 26 Sep 2021 06:51:26 -0400

notcurses (2.4.2+dfsg.1-2) unstable; urgency=medium

  * Update symbol files for libnotcurses-core2

 -- Nick Black <dankamongmen@gmail.com>  Mon, 20 Sep 2021 09:04:25 -0400

notcurses (2.4.2+dfsg.1-1) unstable; urgency=medium

  * New upstream release

 -- Nick Black <dankamongmen@gmail.com>  Mon, 20 Sep 2021 08:11:35 -0400

notcurses (2.4.1+dfsg.1-1) unstable; urgency=medium

  * New upstream version

 -- Nick Black <dankamongmen@gmail.com>  Sun, 12 Sep 2021 22:28:55 -0400

notcurses (2.4.0+dfsg.1-1) unstable; urgency=medium

  * New upstream version

 -- Nick Black <dankamongmen@gmail.com>  Mon, 06 Sep 2021 05:32:31 -0400

notcurses (2.3.18+dfsg.1-1) unstable; urgency=medium

  * Add dep on libgpm-dev and use -DUSE_GPM=on.
  * New upstream version, primarily bugfixes.

 -- Nick Black <dankamongmen@gmail.com>  Tue, 31 Aug 2021 20:09:01 -0400

notcurses (2.3.17+dfsg.1-1) unstable; urgency=medium

  * New upstream version, supporting pixel plots.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 22 Aug 2021 16:13:40 -0400

notcurses (2.3.16+dfsg.1-1) unstable; urgency=medium

  * Policy conformance to 4.6.0. New upstream version fixes
    unit tests in certain rare environments.

 -- Nick Black <dankamongmen@gmail.com>  Thu, 19 Aug 2021 22:18:19 -0400

notcurses (2.3.15+dfsg.1-1) unstable; urgency=medium

  * New upstream with support for Linux framebuffer console.

 -- Nick Black <dankamongmen@gmail.com>  Tue, 17 Aug 2021 19:20:22 -0400

notcurses (2.3.13+dfsg.1-2) unstable; urgency=medium

  * Reenable autopkgtest for notcurses-demo

 -- Nick Black <dankamongmen@gmail.com>  Mon, 16 Aug 2021 00:18:39 -0400

=== debian/control ===
Source: notcurses
Priority: optional
Maintainer: Nick Black <dankamongmen@gmail.com>
Build-Depends: cmake (>= 3.14),
               debhelper-compat (= 13),
               dh-python (>= 4.20191017),
               dh-sequence-python3,
               doctest-dev,
               libavformat-dev (>= 7:4.2.1),
               libavutil-dev (>= 7:4.2.1),
               libdeflate-dev,
               libgpm-dev,
               libncurses-dev,
               libqrcodegen-dev (>= 1.5.0),
               libswscale-dev (>= 7:4.2.1),
               libunistring-dev,
               pandoc (>= 1.19.2.4),
               pkg-config,
               python3-cffi (>= 1.13.2),
               python3-dev,
               python3-pip (>= 20.0),
               python3-pypandoc,
               python3-setuptools (>= 44.0.0)
Standards-Version: 4.6.0
Section: libs
X-Python3-Version: >= 3.7
Rules-Requires-Root: no
Homepage: https://nick-black.com/dankwiki/index.php/Notcurses
Vcs-Browser: https://salsa.debian.org/debian/notcurses
Vcs-Git: https://salsa.debian.org/debian/notcurses.git

Package: libnotcurses++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnotcurses++3 (= ${binary:Version}),
         libnotcurses-dev (>= ${binary:Version}),
         ${misc:Depends}
Description: Character graphics and TUI library (C++ development)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files are necessary for C++ development using Notcurses.

Package: libnotcurses++3
Architecture: any
Multi-Arch: same
Recommends: ncurses-term
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Character graphics and TUI library (C++)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.

Package: libnotcurses-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnotcurses-core3 (= ${binary:Version}), ${misc:Depends}
Recommends: libnotcurses-dev
Description: Character graphics and TUI library (core development)
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. This development
 package covers the Notcurses core library.
 .
 These files are necessary for C development using Notcurses. They
 do not include multimedia support; that requires libnotcurses-dev.

Package: libnotcurses-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnotcurses-core-dev (>= ${binary:Version}),
         libnotcurses3 (= ${binary:Version}),
         ${misc:Depends}
Description: Character graphics and TUI library (development)
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 These files are necessary for C development using Notcurses. This
 package installs multimedia support atop libnotcurses-core-dev.

Package: libnotcurses-core3
Architecture: any
Multi-Arch: same
Recommends: libnotcurses3, ncurses-term
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Character graphics and TUI library (core)
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor.
 .
 This core library lacks multimedia support. For that,
 libnotcurses3 must be installed.

Package: libnotcurses3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Character graphics and TUI library
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 This package provides multimedia support via ffmpeg.

Package: notcurses-bin
Architecture: any
Multi-Arch: foreign
Section: graphics
Depends: notcurses-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: desktop-base,
            ncurses-term,
            python3-notcurses (>= ${source:Version})
Description: Character graphics and TUI library demos
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These utilities from the Notcurses project include notcurses-demo
 (a demonstration of various libnotcurses capabilities), ncplayer
 (a character mode multimedia player), ncls (a file lister that
 displays multimedia), and other tools. Unit tests are furthermore
 bundled as notcurses-tester.

Package: notcurses-data
Architecture: all
Multi-Arch: foreign
Section: graphics
Depends: ${misc:Depends}
Recommends: ncurses-term
Description: Multimedia used by notcurses-bin
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 This package contains multimedia used by notcurses-demo
 and notcurses-tester from the notcurses-bin package.

Package: python3-notcurses
Section: python
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Provides: ${python3:Provides}
Replaces: notcurses-bin (<< 1.6)
Breaks: notcurses-bin (<< 1.6)
Description: Character graphics and TUI library (Python)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files are necessary for Python development using Notcurses.
 The notcurses-pydemo script verifies these Python wrappers.

=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,12 @@
 	dh $@ --buildsystem=cmake
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DDFSG_BUILD=on -DUSE_POC=off -DUSE_QRCODEGEN=on
+	dh_auto_configure -- \
+		-DBUILD_FFI_LIBRARY=off \
+		-DDFSG_BUILD=on \
+		-DUSE_GPM=on \
+		-DUSE_POC=off \
+		-DUSE_QRCODEGEN=on
 
 override_dh_auto_build:
 	dh_auto_build

=== debian/tests/control ===
--- 
+++ 
@@ -3,17 +3,23 @@
 # commands. They'd otherwise fail out, or (worse) not actually test anything.
 
 # Connects to and queries the controlling terminal, dumping info
-Test-Command: TERM=xterm-256color notcurses-info
+Test-Command: TERM=xterm-256color notcurses-info -v
 Depends: notcurses-bin
 Restrictions: allow-stderr
 Features: test-name=info
 
 # Basic unit test suite, but run with installed binary
 # redirect to /dev/null to not overwhelm builder logging
-Test-Command: TERM=xterm-256color notcurses-tester > /dev/null
+Test-Command: TERM=xterm-256color notcurses-tester -l3 > /dev/null
 Depends: notcurses-bin
 Restrictions: allow-stderr
 Features: test-name=unittests
+
+# Execute notcurses-demo with a fixed PRNG seed
+Test-Command: TERM=xterm-256color notcurses-demo -d0 -c -l3
+Depends: notcurses-bin
+Restrictions: allow-stderr
+Features: test-name=demo
 
 # Execute notcurses-pydemo
 Test-Command: TERM=xterm-256color notcurses-pydemo

## notcurses 3.0.7%2Bdfsg.1

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 
+include /usr/share/dpkg/architecture.mk
 DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DEB_BUILD_MAINT_OPTIONS=reproducible=+fixfilepath
